/***
*
*	Copyright (c) 1996-2001, Valve LLC. All rights reserved.
*	
*	This product contains software technology licensed from Id 
*	Software, Inc. ("Id Technology").  Id Technology (c) 1996 Id Software, Inc. 
*	All Rights Reserved.
*
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted to non-commercial enhancements to products from
*   Valve LLC.  All other use, distribution, or modification is prohibited
*   without written permission from Valve LLC.
*
****/
/*

===== h_export.cpp ========================================================

  Entity classes exported by Halflife.

*/

#include "extdll.h"
#include "util.h"

#include "cbase.h"

// Holds engine functionality callbacks
enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;


#if !defined(_MSC_VER) && !defined(__linux__)
// needed for Borland and MinGW since HL engine uses MSVC name mangled exports
void FreeNameFuncGlobals(void);
void LoadSymbols();
HINSTANCE h_DllInstance;
// needed for MinGW to support DllMain entry/exit function...
extern "C" EXPORT BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved);
#endif

#ifdef _WIN32

// Required DLL entry point
BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
   if (fdwReason == DLL_PROCESS_ATTACH)
   {
#ifndef _MSC_VER
        h_DllInstance = hinstDLL;
#endif
   }
   else if (fdwReason == DLL_PROCESS_DETACH)
   {
#ifndef _MSC_VER
       FreeNameFuncGlobals();  // Free exported symbol table for Borland and MinGW
#endif
   }

   return TRUE;
}

#ifdef _MSC_VER  // for Microsoft Visual C++...
void DLLEXPORT GiveFnptrsToDll(	enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
#else  // for Borland and MinGW...
extern "C" DLLEXPORT void EXPORT GiveFnptrsToDll(enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals)
#endif
{
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;

#ifndef _MSC_VER
   LoadSymbols();  // Load exported symbol table for Borland and MinGW
#endif
}


#else

extern "C" {

void GiveFnptrsToDll(	enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;
}

}

#endif
